// Author : Nicolas JEAN
// Date   : October 2001
// filename : special.c
// Copyright : Nicolas JEAN 2001 - 2004
// available on http://youpee.salemioche.com

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/unistd.h>
#include <sys/wait.h>
#include "youpee.h"
#include "common.h"
#include "define.h"
#include "special.h"

void do_pre(FILE *in, FILE *out, char *line){
char buf[MAX_LINE_LENGTH];

  while ( getstrline(buf, MAX_LINE_LENGTH, in) != NULL ) {
   if ( ! strncmp_sol(buf, DIESE_ENDPRE) ) break;
   fputs(buf, out);
  }
}

void do_error(FILE *in, FILE *out, char *line){
  fprintf(stderr, get_field(line, 2));
}

void do_exit(FILE *in, FILE *out, char *line){
  exit(1);
}

void do_escape(FILE *in, FILE *out, char *line){
  add_stddefine("<","&lt;");
  add_stddefine(">","&gt;");
}

void do_unescape(FILE *in, FILE *out, char *line){
  del_stddefine("<");
  del_stddefine(">");
}

char *do_unicode(char *field)
{
char *text = get_field(field, 2);
int l=strlen(text);
char *encoded = malloc(sizeof(char) * l * 6);
char *p = encoded;

  while ( *text ) {
    sprintf(p,"&#%d;",*text++);
    while(*p) p++;
  }

  return encoded;
}

